.186
;------------------------------------------------------------
;       ModelCheck9821  ( ResoModeCheck   Ăяo )
;------------------------------------------------------------
ModelCheck9821  PROC   near
                mov     al,MachineID
        ;  1st Gen.
                cmp     al,00h  ; Ap,As,Ae
                jz      M_A1mate 
                cmp     al,80h  ; Ap,As,Ae(H)
                je      M_A1mate
                cmp     al,02h  ; Ce
                je      M_C1multi
                cmp     al,01h  ; fake BA,BX
                jz      M_B1felow
                mov     dx,offset msg_1gen
                cmp     al,0FFh
                jz      M_B1felow

        ; 2nd Gen.
                cmp     al,05h  ; Af
                je      M_A2mate
                cmp     al,81h  ; Af(H)
                je      M_A2mate
                cmp     al,06h  ; Ap2,As2
                je      M_A2mate
                cmp     al,82h  ; Ap2,As2(H)
                je      M_A2mate
                cmp     al,07h  ; B-mate
                je      M_2GEN
                cmp     al,08h  ; Cs2,Ce2
                je      M_2GEN

        ; 3rd Gen.
                cmp     al,0Dh  ; An
                je      M_A3mate
                cmp     al,83h  ; An(H)
                je      M_A3mate
                cmp     al,18h  ; Ap3,As3
                je      M_A3mate
                cmp     al,84h  ; Ap3,As3(H)
                je      M_A3mate
                cmp     al,13h  ; Xt,Xf,Xa
                je      M_XmatePCI
                
        ; 4th Gen.
                
                cmp     al,29h
                je      M_BX4
                cmp     al,22h
                je      M_XE10
                call    CheckEquip
                mov     dx,offset msg_mac_486
ModelCheckOK:   call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                clc
                ret

M_XmatePCI:     mov     dx,offset msg_xmate_pci
                jmp     ModelCheckOK

M_A3mate:       call    AmateEquip
                mov     dx,offset msg_a3mate
                jmp     ModelCheckOK

M_A2mate:       or      flagset,F_GEN2
                call    AmateEquip
                mov     dx,offset msg_a2mate
                jmp     ModelCheckOK

M_A1mate:       or      flagset,F_GEN2
                or      flagset,F_A1MATE
                call    AmateEquip
                mov     dx,offset msg_a1mate
                jmp     ModelCheckOK

M_C1multi:      or      flagset,F_GEN2
                mov     dx,offset msg_c1multi
;;                or      flagset,F_A1MATE
                jmp     ModelCheckOK
M_2GEN:         
                mov     dx,offset msg_2gen
M_B1felow:      or      flagset,F_GEN2
                jmp     ModelCheckOK

M_XE10:         or      flagset,F_GEN4
                mov     dx,offset msg_xe10
                jmp     ModelCheckOK
M_BX4:          or      flagset,F_GEN4
                mov     dx,offset msg_bx4
                jmp     ModelCheckOK

msg_xmate_pci   DB      0E1h," PC-9821Xf,Xt,Xa ",0
msg_a1mate      DB      0E1h," PC-9821Ap,As,Ae ",0
msg_a2mate      DB      0E1h," PC-9821Ap2,As2,Af ",0
msg_a3mate      DB      0E1h," PC-9821An,Ap3,As3 ",0
msg_c1multi     DB      0E1h," PC-9821Ce ",0
msg_1gen        DB      0E1h," PC-9801BA,BX ",0
msg_2gen        DB      0E1h," PC-9821Ce2,Cs2, Bp,Bs,Be, PC-9801 BX2,BA2 ",0
msg_bx4         DB      0E1h," PC-9801BX4 ",0
msg_xe10        DB      0E1h," PC-9821Xe10 ",0
msg_mac_486     DB      0E1h," Generic i486 PC-9821/9801 ذ ",0

ModelCheck9821  ENDP

;-------------------------------------------
;       CheckEquip
;-------------------------------------------
CheckEquip      PROC   near
                jmp     CheckEquip2
                ret
CheckEquip      ENDP
;-------------------------------------------
;       AmateEquip
;-------------------------------------------
AmateEquip      PROC   near
                in      al,0F0h
                test    al,40h          ; Internal SCSI exist?
                jnz     @f
                or      equip,E10_equip
        @@:
CheckEquip2:
                test    flagset,F_HIRESO
                jnz     ExitAmateEquip
                mov     al,flagset
                test    flagset,F_A1MATE
                jnz     Sound_A1mate
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      ExitAmateEquip   ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip ; TEhBIOSL
                jmp     ExitAmateEquip
Sound_A1mate: ; A-mateL̕sVXeɂ@ 2024/4/8 
                mov     dx,046Ch
                mov     al,02h
                out     dx,al
                mov     dx,0468h
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx   ; KTAœǂݏo
                test    al,1    ; SOUND BIOSLbit 0, ڑtL bit 2
                jNz     ExitAmateEquip ; SOUND BIOSL
                or      equip,SND_equip ;
ExitAmateEquip: 
                or      equip,IDE_equip ; IDE BIOS o
                ret
AmateEquip      ENDP

;------------------------------------------------------------
;       ResoModeCheck   ŏɂP񂾂Ăяo`FbN
;------------------------------------------------------------
ResoModeCheck   PROC    near
                mov     MemWindowAddr,0Ch
                mov     MemWindowNative,08h
                mov     mem_bank_IOaddr,0461h
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0458h]
                jz      @f
                or      flagset,F_H98
        @@:
                mov     al,es:[0501h]           ; hi-reso check
                and     al,8    ; 1000b           1      0
                shr     al,2    ;   10b                  0
                add     MemWindowAddr,al        ; 0Eh    0Ch
                shr     al,1    ;    1b
                or      flagset,al      ; high/low mode flag
                mov     dx,0A000h       ; Text VRAMZOg
                mov     bx,0F8E8h       ; Machine ID i[ZOg(BIOS)
                mov     ah,00h          ; AH bit 7Machine ID̈ꕔɎg
                or      al,al
                jz      NormalResoMode  
; HIRESOLUTION MODE SETTINGS
                mov     mem_bank_IOaddr,0091h ; Hireso mem-window port
                mov     MemWindowNative,10h;  Hireso mem-window native addr
                mov     dx,0E000h       ; The segment of Text VRAM at H mode
                mov     bx,0FFE8h       ; The segment of Machine ID flag at H.
                mov     ah,80h          ; bit7=1 , Machine ID nC]rbg
NormalResoMode: mov     es,dx           
                mov     SegTVRAM,dx     ; TEXT VRAMZOgLϐɊi[
                push    ds
                mov     ds,bx
                mov     dx,ds:[0]
                mov     al,ds:[003Fh]
                pop     ds
                or      al,ah           ; nC]bitƍ
                cmp     dx,2198h
                je      @f
                mov     MachineID,0FFh
                stc
                ret
        @@:     clc
                mov     MachineID,al
                ret
ResoModeCheck   ENDP


;--------------------------------------2022/2/1-----
;       CheckEPSONPC
;---------------------------------------------------
CheckEPSONPC    PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]       ; EPSON ID
                mov     ah,0
                or      flagset,F_EPSON
                stc     ; CY=EPSON PC
                ret
CheckEPSONPC    ENDP

;--------------------------------------------------------------
;       CheckCPU386     ȈՂCPU386
;--------------------------------------------------------------
CheckCPU386     PROC   near;  ϐ CPUtype  x=0..6
                xor     ax,ax
                mov     es,ax
                mov     dx,es:[0486h]

                pushf
                pop     ax
                pushf
                or      ax,4000h
                push    ax
                popf
                pushf
                pop     ax
                popf
                and     ax,0C000h
                cmp     ax,4000h
                jNe     Not386
                or      flagset, F_386
                cmp     dx,0            ; if XL^2  then 0
                jne     @f              ;       else CPUID
                mov     ax,0300h   ; forced 386
        @@:     
                mov     CPUtype,AH
                clc
                ret
Not386:         
                pushf
                pop     ax
                test    ax,8000h
                jnz     Not286
                mov     ax,0200h
                mov     CPUtype,ah
                stc
                ret
Not286:         mov     ax,0100h
                DB      0D5h,00h        ; AAD 00(V30)    AAD(intel)
                jz      NotV30          ; AL=0          AL=0Ah
                mov     ax,0100h        ; V30's CPUID is set to 0100h
                mov     CPUtype,ah
NotV30:
                stc
                ret
CheckCPU386     ENDP

