
;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                cld
                mov     cx,2000h/2      ; 8KB
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,MEMseg
                push    es
                push    ds
                mov     es,ax   ; ES=AX=MEMseg
                mov     ds,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
          rep   movsw
                pop     ds
                pop     es
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE  (ex)     A-mate
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al

                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al

                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address C000 or E000h.
                out     dx,al
                
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al

                ret
RAMROM486_IDE   ENDP
